Fix burnin install path
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 hypervisordir = $(pkgpythondir)/hypervisor
44 httpdir = $(pkgpythondir)/http
45 masterddir = $(pkgpythondir)/masterd
46 confddir = $(pkgpythondir)/confd
47 rapidir = $(pkgpythondir)/rapi
48 serverdir = $(pkgpythondir)/server
49 watcherdir = $(pkgpythondir)/watcher
50 impexpddir = $(pkgpythondir)/impexpd
51 utilsdir = $(pkgpythondir)/utils
52 toolsdir = $(pkglibdir)/tools
53 iallocatorsdir = $(pkglibdir)/iallocators
54 pytoolsdir = $(pkgpythondir)/tools
55 docdir = $(datadir)/doc/$(PACKAGE)
56 myexeclibdir = $(pkglibdir)
57
58 # Delete output file if an error occurred while building it
59 .DELETE_ON_ERROR:
60
61 HS_DIRS = \
62         src \
63         src/Ganeti \
64         src/Ganeti/Block \
65         src/Ganeti/Block/Drbd \
66         src/Ganeti/Confd \
67         src/Ganeti/DataCollectors \
68         src/Ganeti/HTools \
69         src/Ganeti/HTools/Backend \
70         src/Ganeti/HTools/Program \
71         src/Ganeti/Query \
72         test/hs \
73         test/hs/Test \
74         test/hs/Test/Ganeti \
75         test/hs/Test/Ganeti/Block \
76         test/hs/Test/Ganeti/Block/Drbd \
77         test/hs/Test/Ganeti/Confd \
78         test/hs/Test/Ganeti/HTools \
79         test/hs/Test/Ganeti/HTools/Backend \
80         test/hs/Test/Ganeti/Query
81
82 # Haskell directories without the roots (src, test/hs)
83 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
84
85 DIRS = \
86         $(HS_DIRS) \
87         autotools \
88         daemons \
89         devel \
90         doc \
91         doc/css \
92         doc/examples \
93         doc/examples/gnt-debug \
94         doc/examples/hooks \
95         test/data/htools \
96         test/data/htools/rapi \
97         test/hs/shelltests \
98         lib \
99         lib/build \
100         lib/client \
101         lib/confd \
102         lib/http \
103         lib/hypervisor \
104         lib/impexpd \
105         lib/masterd \
106         lib/rapi \
107         lib/server \
108         lib/tools \
109         lib/utils \
110         lib/watcher \
111         man \
112         qa \
113         test \
114         test/data \
115         test/data/bdev-rbd \
116         test/data/ovfdata \
117         test/data/ovfdata/other \
118         test/py \
119         tools
120
121 ALL_APIDOC_HS_DIRS = \
122         $(APIDOC_HS_DIR) \
123         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
124
125 BUILDTIME_DIR_AUTOCREATE = \
126         scripts \
127         $(APIDOC_DIR) \
128         $(ALL_APIDOC_HS_DIRS) \
129         $(APIDOC_PY_DIR) \
130         $(COVERAGE_DIR) \
131         $(COVERAGE_HS_DIR) \
132         $(COVERAGE_PY_DIR) \
133         .hpc
134
135 BUILDTIME_DIRS = \
136         $(BUILDTIME_DIR_AUTOCREATE) \
137         doc/html \
138         doc/man-html
139
140 DIRCHECK_EXCLUDE = \
141         $(BUILDTIME_DIRS) \
142         ganeti-[0-9]*.[0-9]*.[0-9]* \
143         doc/html/_* \
144         doc/man-html/_* \
145         autom4te.cache
146
147 # some helper vars
148 COVERAGE_DIR = doc/coverage
149 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
150 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
151 APIDOC_DIR = doc/api
152 APIDOC_PY_DIR = $(APIDOC_DIR)/py
153 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
154
155 MAINTAINERCLEANFILES = \
156         $(maninput) \
157         doc/install-quick.rst \
158         doc/news.rst \
159         doc/upgrade.rst \
160         vcs-version
161
162 maintainer-clean-local:
163         rm -rf $(BUILDTIME_DIRS)
164
165 CLEANFILES = \
166         $(addsuffix /*.py[co],$(DIRS)) \
167         $(addsuffix /*.hi,$(HS_DIRS)) \
168         $(addsuffix /*.o,$(HS_DIRS)) \
169         $(PYTHON_BOOTSTRAP) \
170         epydoc.conf \
171         $(REPLACE_VARS_SED) \
172         $(SHELL_ENV_INIT) \
173         daemons/daemon-util \
174         daemons/ganeti-cleaner \
175         $(mandocrst) \
176         doc/manpages-enabled.rst \
177         $(BUILT_EXAMPLES) \
178         doc/examples/bash_completion \
179         doc/examples/bash_completion-debug \
180         lib/_generated_rpc.py \
181         $(man_MANS) \
182         $(manhtml) \
183         tools/kvm-ifup \
184         tools/users-setup \
185         tools/vcluster-setup \
186         stamp-directories \
187         stamp-srclinks \
188         $(nodist_pkgpython_PYTHON) \
189         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
190         $(HS_BUILT_TEST_HELPERS) \
191         src/ganeti-confd \
192         .hpc/*.mix src/*.tix test/hs/*.tix \
193         doc/hs-lint.html
194
195 GENERATED_FILES = \
196         $(built_base_sources) \
197         $(BUILT_PYTHON_SOURCES) \
198         $(PYTHON_BOOTSTRAP)
199
200 HS_GENERATED_FILES =
201 if WANT_HTOOLS
202 HS_GENERATED_FILES += $(HS_PROGS)
203 if ENABLE_CONFD
204 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
205 endif
206 endif
207
208 built_base_sources = \
209         stamp-directories \
210         stamp-srclinks
211
212 built_python_base_sources = \
213         lib/_autoconf.py \
214         lib/_vcsversion.py
215
216 BUILT_PYTHON_SOURCES = \
217         $(built_python_base_sources) \
218         lib/_generated_rpc.py
219
220 # Generating the RPC wrappers depends on many things, so make sure
221 # it's built at the end of the built sources
222 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
223
224 # these are all built from the underlying %.in sources
225 BUILT_EXAMPLES = \
226         doc/examples/ganeti-kvm-poweroff.initd \
227         doc/examples/ganeti.cron \
228         doc/examples/ganeti.initd \
229         doc/examples/ganeti-master-role.ocf \
230         doc/examples/ganeti-node-role.ocf \
231         doc/examples/gnt-config-backup \
232         doc/examples/hooks/ipsec
233
234 nodist_pkgpython_PYTHON = \
235         $(BUILT_PYTHON_SOURCES)
236
237 noinst_PYTHON = \
238         lib/build/__init__.py \
239         lib/build/shell_example_lexer.py \
240         lib/build/sphinx_ext.py
241
242 pkgpython_PYTHON = \
243         lib/__init__.py \
244         lib/asyncnotifier.py \
245         lib/backend.py \
246         lib/bdev.py \
247         lib/bootstrap.py \
248         lib/cli.py \
249         lib/cmdlib.py \
250         lib/compat.py \
251         lib/config.py \
252         lib/constants.py \
253         lib/daemon.py \
254         lib/errors.py \
255         lib/ht.py \
256         lib/jqueue.py \
257         lib/jstore.py \
258         lib/locking.py \
259         lib/luxi.py \
260         lib/mcpu.py \
261         lib/netutils.py \
262         lib/objects.py \
263         lib/opcodes.py \
264         lib/outils.py \
265         lib/ovf.py \
266         lib/pathutils.py \
267         lib/qlang.py \
268         lib/query.py \
269         lib/rpc.py \
270         lib/rpc_defs.py \
271         lib/runtime.py \
272         lib/serializer.py \
273         lib/ssconf.py \
274         lib/ssh.py \
275         lib/storage.py \
276         lib/uidpool.py \
277         lib/vcluster.py \
278         lib/network.py \
279         lib/workerpool.py
280
281 client_PYTHON = \
282         lib/client/__init__.py \
283         lib/client/gnt_backup.py \
284         lib/client/gnt_cluster.py \
285         lib/client/gnt_debug.py \
286         lib/client/gnt_group.py \
287         lib/client/gnt_instance.py \
288         lib/client/gnt_job.py \
289         lib/client/gnt_node.py \
290         lib/client/gnt_network.py \
291         lib/client/gnt_os.py \
292         lib/client/gnt_storage.py
293
294 hypervisor_PYTHON = \
295         lib/hypervisor/__init__.py \
296         lib/hypervisor/hv_base.py \
297         lib/hypervisor/hv_chroot.py \
298         lib/hypervisor/hv_fake.py \
299         lib/hypervisor/hv_kvm.py \
300         lib/hypervisor/hv_lxc.py \
301         lib/hypervisor/hv_xen.py
302
303 rapi_PYTHON = \
304         lib/rapi/__init__.py \
305         lib/rapi/baserlib.py \
306         lib/rapi/client.py \
307         lib/rapi/client_utils.py \
308         lib/rapi/connector.py \
309         lib/rapi/rlib2.py \
310         lib/rapi/testutils.py
311
312 http_PYTHON = \
313         lib/http/__init__.py \
314         lib/http/auth.py \
315         lib/http/client.py \
316         lib/http/server.py
317
318 confd_PYTHON = \
319         lib/confd/__init__.py \
320         lib/confd/client.py
321
322 masterd_PYTHON = \
323         lib/masterd/__init__.py \
324         lib/masterd/iallocator.py \
325         lib/masterd/instance.py
326
327 impexpd_PYTHON = \
328         lib/impexpd/__init__.py
329
330 watcher_PYTHON = \
331         lib/watcher/__init__.py \
332         lib/watcher/nodemaint.py \
333         lib/watcher/state.py
334
335 server_PYTHON = \
336         lib/server/__init__.py \
337         lib/server/masterd.py \
338         lib/server/noded.py \
339         lib/server/rapi.py
340
341 pytools_PYTHON = \
342         lib/tools/__init__.py \
343         lib/tools/burnin.py \
344         lib/tools/ensure_dirs.py \
345         lib/tools/node_cleanup.py \
346         lib/tools/node_daemon_setup.py \
347         lib/tools/prepare_node_join.py
348
349 utils_PYTHON = \
350         lib/utils/__init__.py \
351         lib/utils/algo.py \
352         lib/utils/filelock.py \
353         lib/utils/hash.py \
354         lib/utils/io.py \
355         lib/utils/log.py \
356         lib/utils/lvm.py \
357         lib/utils/mlock.py \
358         lib/utils/nodesetup.py \
359         lib/utils/process.py \
360         lib/utils/retry.py \
361         lib/utils/text.py \
362         lib/utils/wrapper.py \
363         lib/utils/x509.py
364
365 docinput = \
366         doc/conf.py \
367         doc/css/style.css \
368         doc/admin.rst \
369         doc/cluster-merge.rst \
370         doc/design-2.0.rst \
371         doc/design-2.1.rst \
372         doc/design-2.2.rst \
373         doc/design-2.3.rst \
374         doc/design-2.4.rst \
375         doc/design-2.5.rst \
376         doc/design-2.6.rst \
377         doc/design-2.7.rst \
378         doc/design-autorepair.rst \
379         doc/design-bulk-create.rst \
380         doc/design-chained-jobs.rst \
381         doc/design-cpu-pinning.rst \
382         doc/design-draft.rst \
383         doc/design-htools-2.3.rst \
384         doc/design-http-server.rst \
385         doc/design-impexp2.rst \
386         doc/design-lu-generated-jobs.rst \
387         doc/design-linuxha.rst \
388         doc/design-multi-reloc.rst \
389         doc/design-network.rst \
390         doc/design-node-add.rst \
391         doc/design-oob.rst \
392         doc/design-ovf-support.rst \
393         doc/design-opportunistic-locking.rst \
394         doc/design-partitioned.rst \
395         doc/design-query-splitting.rst \
396         doc/design-query2.rst \
397         doc/design-resource-model.rst \
398         doc/design-restricted-commands.rst \
399         doc/design-shared-storage.rst \
400         doc/design-monitoring-agent.rst \
401         doc/design-virtual-clusters.rst \
402         doc/design-x509-ca.rst \
403         doc/devnotes.rst \
404         doc/glossary.rst \
405         doc/hooks.rst \
406         doc/iallocator.rst \
407         doc/index.rst \
408         doc/install-quick.rst \
409         doc/install.rst \
410         doc/locking.rst \
411         doc/manpages-disabled.rst \
412         doc/move-instance.rst \
413         doc/news.rst \
414         doc/ovfconverter.rst \
415         doc/rapi.rst \
416         doc/security.rst \
417         doc/upgrade.rst \
418         doc/virtual-cluster.rst \
419         doc/walkthrough.rst
420
421 # Generates file names such as "doc/man-gnt-instance.rst"
422 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
423
424 # Haskell programs to be installed in $PREFIX/bin
425 HS_BIN_PROGS=src/htools
426
427 # Haskell programs to be installed in the MYEXECLIB dir
428 HS_MYEXECLIB_PROGS=src/mon-collector
429
430 # Haskell programs to compiled but not installed automatically
431 # Usually they have their own specific installation rules
432 HS_COMPILE_PROGS= \
433         src/hconfd \
434         src/rpc-test
435
436 # All Haskell non-test programs to be compiled but not automatically installed
437 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
438
439 HS_BIN_ROLES = hbal hscan hspace hinfo hcheck hroller
440 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
441
442 HS_ALL_PROGS = \
443         $(HS_PROGS) \
444         test/hs/hpc-htools \
445         test/hs/hpc-mon-collector \
446         test/hs/htest \
447         $(HS_COMPILE_PROGS)
448
449 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
450 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
451
452 HFLAGS = \
453         -O -Wall -Werror -isrc \
454         -fwarn-monomorphism-restriction \
455         -fwarn-tabs \
456         $(GHC_BYVERSION_FLAGS)
457
458 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
459 HEXTRA =
460 # internal extra flags (used for test/hs/htest mainly)
461 HEXTRA_INT =
462 # exclude options for coverage reports
463 HPCEXCL = --exclude Main \
464         --exclude Ganeti.Constants \
465         --exclude Ganeti.HTools.QC \
466         --exclude Ganeti.THH \
467         --exclude Ganeti.Version \
468         --exclude Test.Ganeti.Attoparsec \
469         --exclude Test.Ganeti.TestCommon \
470         --exclude Test.Ganeti.TestHTools \
471         --exclude Test.Ganeti.TestHelper \
472         --exclude Test.Ganeti.TestImports \
473         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
474
475 HS_LIB_SRCS = \
476         src/Ganeti/Block/Drbd/Types.hs \
477         src/Ganeti/Block/Drbd/Parser.hs \
478         src/Ganeti/BasicTypes.hs \
479         src/Ganeti/Common.hs \
480         src/Ganeti/Compat.hs \
481         src/Ganeti/Confd/Client.hs \
482         src/Ganeti/Confd/Server.hs \
483         src/Ganeti/Confd/Types.hs \
484         src/Ganeti/Confd/Utils.hs \
485         src/Ganeti/Config.hs \
486         src/Ganeti/Daemon.hs \
487         src/Ganeti/DataCollectors/CLI.hs \
488         src/Ganeti/DataCollectors/Drbd.hs \
489         src/Ganeti/DataCollectors/Program.hs \
490         src/Ganeti/DataCollectors/Types.hs \
491         src/Ganeti/Errors.hs \
492         src/Ganeti/HTools/Backend/IAlloc.hs \
493         src/Ganeti/HTools/Backend/Luxi.hs \
494         src/Ganeti/HTools/Backend/Rapi.hs \
495         src/Ganeti/HTools/Backend/Simu.hs \
496         src/Ganeti/HTools/Backend/Text.hs \
497         src/Ganeti/HTools/CLI.hs \
498         src/Ganeti/HTools/Cluster.hs \
499         src/Ganeti/HTools/Container.hs \
500         src/Ganeti/HTools/ExtLoader.hs \
501         src/Ganeti/HTools/Graph.hs \
502         src/Ganeti/HTools/Group.hs \
503         src/Ganeti/HTools/Instance.hs \
504         src/Ganeti/HTools/Loader.hs \
505         src/Ganeti/HTools/Node.hs \
506         src/Ganeti/HTools/PeerMap.hs \
507         src/Ganeti/HTools/Program/Hail.hs \
508         src/Ganeti/HTools/Program/Hbal.hs \
509         src/Ganeti/HTools/Program/Hcheck.hs \
510         src/Ganeti/HTools/Program/Hinfo.hs \
511         src/Ganeti/HTools/Program/Hscan.hs \
512         src/Ganeti/HTools/Program/Hspace.hs \
513         src/Ganeti/HTools/Program/Hroller.hs \
514         src/Ganeti/HTools/Program/Main.hs \
515         src/Ganeti/HTools/Types.hs \
516         src/Ganeti/Hash.hs \
517         src/Ganeti/JQueue.hs \
518         src/Ganeti/JSON.hs \
519         src/Ganeti/Jobs.hs \
520         src/Ganeti/Logging.hs \
521         src/Ganeti/Luxi.hs \
522         src/Ganeti/Network.hs \
523         src/Ganeti/Objects.hs \
524         src/Ganeti/OpCodes.hs \
525         src/Ganeti/OpParams.hs \
526         src/Ganeti/Path.hs \
527         src/Ganeti/Query/Common.hs \
528         src/Ganeti/Query/Filter.hs \
529         src/Ganeti/Query/Group.hs \
530         src/Ganeti/Query/Job.hs \
531         src/Ganeti/Query/Language.hs \
532         src/Ganeti/Query/Node.hs \
533         src/Ganeti/Query/Query.hs \
534         src/Ganeti/Query/Server.hs \
535         src/Ganeti/Query/Types.hs \
536         src/Ganeti/Rpc.hs \
537         src/Ganeti/Runtime.hs \
538         src/Ganeti/Ssconf.hs \
539         src/Ganeti/THH.hs \
540         src/Ganeti/Types.hs \
541         src/Ganeti/Utils.hs
542
543 HS_TEST_SRCS = \
544         test/hs/Test/Ganeti/Attoparsec.hs \
545         test/hs/Test/Ganeti/BasicTypes.hs \
546         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
547         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
548         test/hs/Test/Ganeti/Common.hs \
549         test/hs/Test/Ganeti/Confd/Types.hs \
550         test/hs/Test/Ganeti/Confd/Utils.hs \
551         test/hs/Test/Ganeti/Daemon.hs \
552         test/hs/Test/Ganeti/Errors.hs \
553         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
554         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
555         test/hs/Test/Ganeti/HTools/CLI.hs \
556         test/hs/Test/Ganeti/HTools/Cluster.hs \
557         test/hs/Test/Ganeti/HTools/Container.hs \
558         test/hs/Test/Ganeti/HTools/Graph.hs \
559         test/hs/Test/Ganeti/HTools/Instance.hs \
560         test/hs/Test/Ganeti/HTools/Loader.hs \
561         test/hs/Test/Ganeti/HTools/Node.hs \
562         test/hs/Test/Ganeti/HTools/PeerMap.hs \
563         test/hs/Test/Ganeti/HTools/Types.hs \
564         test/hs/Test/Ganeti/JSON.hs \
565         test/hs/Test/Ganeti/Jobs.hs \
566         test/hs/Test/Ganeti/JQueue.hs \
567         test/hs/Test/Ganeti/Luxi.hs \
568         test/hs/Test/Ganeti/Network.hs \
569         test/hs/Test/Ganeti/Objects.hs \
570         test/hs/Test/Ganeti/OpCodes.hs \
571         test/hs/Test/Ganeti/Query/Filter.hs \
572         test/hs/Test/Ganeti/Query/Language.hs \
573         test/hs/Test/Ganeti/Query/Query.hs \
574         test/hs/Test/Ganeti/Rpc.hs \
575         test/hs/Test/Ganeti/Runtime.hs \
576         test/hs/Test/Ganeti/Ssconf.hs \
577         test/hs/Test/Ganeti/THH.hs \
578         test/hs/Test/Ganeti/TestCommon.hs \
579         test/hs/Test/Ganeti/TestHTools.hs \
580         test/hs/Test/Ganeti/TestHelper.hs \
581         test/hs/Test/Ganeti/Types.hs \
582         test/hs/Test/Ganeti/Utils.hs
583
584 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
585
586 HS_BUILT_SRCS = \
587         test/hs/Test/Ganeti/TestImports.hs \
588         src/Ganeti/Constants.hs \
589         src/Ganeti/Version.hs
590 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
591
592 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
593
594 $(RUN_IN_TEMPDIR): | stamp-directories
595
596 doc/html/index.html: ENABLE_MANPAGES =
597 doc/man-html/index.html: ENABLE_MANPAGES = 1
598 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
599
600 # Note: we use here an order-only prerequisite, as the contents of
601 # _autoconf.py are not actually influencing the html build output: it
602 # has to exist in order for the sphinx module to be loaded
603 # successfully, but we certainly don't want the docs to be rebuilt if
604 # it changes
605 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
606         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
607         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
608         doc/css/style.css \
609         | $(BUILT_PYTHON_SOURCES)
610         @test -n "$(SPHINX)" || \
611             { echo 'sphinx-build' not found during configure; exit 1; }
612 if !MANPAGES_IN_DOC
613         if test -n '$(ENABLE_MANPAGES)'; then \
614           echo 'Man pages in documentation were disabled at configure time' >&2; \
615           exit 1; \
616         fi
617 endif
618 ## Sphinx provides little control over what content should be included. Some
619 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
620 ## build two different versions of the documentation--once without man pages and
621 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
622 ## us with this, but requires running in a temporary directory. It moves the
623 ## correct files into place depending on environment variables.
624         dir=$(dir $@) && \
625         @mkdir_p@ $$dir && \
626         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
627         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
628             -d . \
629             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
630             -D release="$(PACKAGE_VERSION)" \
631             -D graphviz_dot="$(DOT)" \
632             -D enable_manpages="$(ENABLE_MANPAGES)" \
633             doc $(CURDIR)/$$dir && \
634         rm -f $$dir/.buildinfo $$dir/objects.inv
635         touch $@
636
637 doc/html: doc/html/index.html
638
639 doc/man-html: doc/man-html/index.html
640
641 doc/install-quick.rst: INSTALL
642 doc/news.rst: NEWS
643 doc/upgrade.rst: UPGRADE
644
645 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
646         set -e; \
647         { echo '.. This file is automatically updated at build time from $<.'; \
648           echo '.. Do not edit.'; \
649           echo; \
650           cat $<; \
651         } > $@
652
653 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
654         { echo '.. This file is automatically generated, do not edit!'; \
655           echo ''; \
656           echo 'Man pages'; \
657           echo '========='; \
658           echo; \
659           echo '.. toctree::'; \
660           echo '   :maxdepth: 1'; \
661           echo; \
662           for i in $(notdir $(mandocrst)); do \
663             echo "   $$i"; \
664           done | LC_ALL=C sort; \
665         } > $@
666
667 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
668 if MANPAGES_IN_DOC
669         { echo '.. This file is automatically updated at build time from $<.'; \
670           echo '.. Do not edit.'; \
671           echo; \
672           echo "$*"; \
673           echo '=========================================='; \
674           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
675         } > $@
676 else
677         echo 'Man pages in documentation were disabled at configure time' >&2; \
678         exit 1;
679 endif
680
681 # Things to build but not to install (add it to EXTRA_DIST if it should be
682 # distributed)
683 noinst_DATA = \
684         doc/html \
685         $(BUILT_EXAMPLES) \
686         doc/examples/bash_completion \
687         doc/examples/bash_completion-debug \
688         $(manhtml)
689
690 if MANPAGES_IN_DOC
691 noinst_DATA += doc/man-html
692 endif
693
694 gnt_scripts = \
695         scripts/gnt-backup \
696         scripts/gnt-cluster \
697         scripts/gnt-debug \
698         scripts/gnt-group \
699         scripts/gnt-instance \
700         scripts/gnt-job \
701         scripts/gnt-network \
702         scripts/gnt-node \
703         scripts/gnt-os \
704         scripts/gnt-storage
705
706 PYTHON_BOOTSTRAP_SBIN = \
707         daemons/ganeti-masterd \
708         daemons/ganeti-noded \
709         daemons/ganeti-rapi \
710         daemons/ganeti-watcher \
711         $(gnt_scripts)
712
713 PYTHON_BOOTSTRAP = \
714         $(PYTHON_BOOTSTRAP_SBIN) \
715         tools/burnin \
716         tools/ensure-dirs \
717         tools/node-cleanup \
718         tools/node-daemon-setup \
719         tools/prepare-node-join
720
721 qa_scripts = \
722         qa/__init__.py \
723         qa/ganeti-qa.py \
724         qa/qa_cluster.py \
725         qa/qa_config.py \
726         qa/qa_daemon.py \
727         qa/qa_env.py \
728         qa/qa_error.py \
729         qa/qa_group.py \
730         qa/qa_instance.py \
731         qa/qa_job.py \
732         qa/qa_node.py \
733         qa/qa_os.py \
734         qa/qa_rapi.py \
735         qa/qa_tags.py \
736         qa/qa_utils.py
737
738 bin_SCRIPTS =
739 if WANT_HTOOLS
740 bin_SCRIPTS += $(HS_BIN_PROGS)
741 install-exec-hook:
742         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
743 # FIXME: this is a hardcoded logic, instead of auto-resolving
744         $(LN_S) -f ../../../bin/htools \
745           $(DESTDIR)$(iallocatorsdir)/hail
746         for role in $(HS_BIN_ROLES); do \
747           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
748         done
749 endif
750
751 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
752         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
753           echo "Error: cannot run unittests without the development" \
754                " libraries (see devnotes.rst)" 1>&2; \
755           exit 1; \
756         fi
757         @rm -f $(notdir $@).tix
758         $(GHC) --make \
759           $(HFLAGS) \
760           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
761           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
762           $(HEXTRA) $(HEXTRA_INT) $@
763         @touch "$@"
764
765 # for the test/hs/htest binary, we need to enable profiling/coverage
766 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
767
768 # we compile the hpc-htools binary with the program coverage
769 test/hs/hpc-htools: HEXTRA_INT=-fhpc
770
771 # we compile the hpc-mon-collector binary with the program coverage
772 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
773
774 # test dependency
775 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
776
777 # rules for building profiling-enabled versions of the haskell
778 # programs: hs-prof does the full two-step build, whereas
779 # hs-prof-quick does only the final rebuild (hs-prof must have been
780 # run before)
781 .PHONY: hs-prof hs-prof-quick
782 hs-prof:
783         @if [ -z "$(TARGET)" ]; then \
784           echo "You need to define TARGET when running this rule" 1>&2; \
785           exit 1; \
786         fi
787         $(MAKE) $(AM_MAKEFLAGS) clean
788         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
789         rm -f $(HS_ALL_PROGS)
790         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
791
792 hs-prof-quick:
793         @if [ -z "$(TARGET)" ]; then \
794           echo "You need to define TARGET when running this rule" 1>&2; \
795           exit 1; \
796         fi
797         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
798
799 dist_sbin_SCRIPTS = \
800         tools/ganeti-listrunner
801
802 nodist_sbin_SCRIPTS = \
803         $(PYTHON_BOOTSTRAP_SBIN) \
804         daemons/ganeti-cleaner
805
806 if ENABLE_CONFD
807 src/ganeti-confd: src/hconfd
808         cp -f $< $@
809
810 nodist_sbin_SCRIPTS += src/ganeti-confd
811 endif
812
813 python_scripts = \
814         tools/cfgshell \
815         tools/cfgupgrade \
816         tools/cfgupgrade12 \
817         tools/cluster-merge \
818         tools/confd-client \
819         tools/fmtjson \
820         tools/lvmstrap \
821         tools/move-instance \
822         tools/ovfconverter \
823         tools/sanitize-config
824
825 dist_tools_SCRIPTS = \
826         $(python_scripts) \
827         tools/burnin \
828         tools/kvm-console-wrapper \
829         tools/master-ip-setup \
830         tools/xen-console-wrapper
831
832 nodist_tools_python_scripts = \
833         tools/node-cleanup
834
835 nodist_tools_SCRIPTS = \
836         $(nodist_tools_python_scripts) \
837         tools/users-setup \
838         tools/vcluster-setup
839
840 pkglib_python_scripts = \
841         daemons/import-export \
842         tools/check-cert-expired
843
844 nodist_pkglib_python_scripts = \
845         tools/ensure-dirs \
846         tools/node-daemon-setup \
847         tools/prepare-node-join
848
849 myexeclib_SCRIPTS = \
850         daemons/daemon-util \
851         tools/kvm-ifup \
852         $(pkglib_python_scripts) \
853         $(HS_MYEXECLIB_PROGS)
854
855 nodist_myexeclib_SCRIPTS = \
856         $(nodist_pkglib_python_scripts)
857
858 EXTRA_DIST = \
859         NEWS \
860         UPGRADE \
861         epydoc.conf.in \
862         pylintrc \
863         autotools/build-bash-completion \
864         autotools/build-rpc \
865         autotools/check-header \
866         autotools/check-imports \
867         autotools/check-man-dashes \
868         autotools/check-man-references \
869         autotools/check-man-warnings \
870         autotools/check-news \
871         autotools/check-python-code \
872         autotools/check-tar \
873         autotools/check-version \
874         autotools/convert-constants \
875         autotools/docpp \
876         autotools/gen-py-coverage \
877         autotools/sphinx-wrapper \
878         autotools/testrunner \
879         autotools/wrong-hardcoded-paths \
880         $(RUN_IN_TEMPDIR) \
881         daemons/daemon-util.in \
882         daemons/ganeti-cleaner.in \
883         $(pkglib_python_scripts) \
884         devel/upload \
885         devel/webserver \
886         tools/kvm-ifup.in \
887         tools/users-setup.in \
888         tools/vcluster-setup.in \
889         $(docinput) \
890         doc/html \
891         $(BUILT_EXAMPLES:%=%.in) \
892         doc/examples/ganeti.default \
893         doc/examples/ganeti.default-debug \
894         doc/examples/hooks/ethers \
895         doc/examples/gnt-debug/README \
896         doc/examples/gnt-debug/delay0.json \
897         doc/examples/gnt-debug/delay50.json \
898         test/py/lockperf.py \
899         test/py/testutils.py \
900         test/py/mocks.py \
901         $(dist_TESTS) \
902         $(TEST_FILES) \
903         man/footer.rst \
904         $(manrst) \
905         $(maninput) \
906         qa/qa-sample.json \
907         $(qa_scripts) \
908         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
909         $(HS_PROG_SRCS) \
910         src/lint-hints.hs \
911         test/hs/cli-tests-defs.sh \
912         test/hs/offline-test.sh \
913         .ghci
914
915 man_MANS = \
916         man/ganeti-cleaner.8 \
917         man/ganeti-confd.8 \
918         man/ganeti-listrunner.8 \
919         man/ganeti-masterd.8 \
920         man/ganeti-noded.8 \
921         man/ganeti-os-interface.7 \
922         man/ganeti-extstorage-interface.7 \
923         man/ganeti-rapi.8 \
924         man/ganeti-watcher.8 \
925         man/ganeti.7 \
926         man/gnt-backup.8 \
927         man/gnt-cluster.8 \
928         man/gnt-debug.8 \
929         man/gnt-group.8 \
930         man/gnt-network.8 \
931         man/gnt-instance.8 \
932         man/gnt-job.8 \
933         man/gnt-node.8 \
934         man/gnt-os.8 \
935         man/gnt-storage.8 \
936         man/hail.1 \
937         man/hbal.1 \
938         man/hcheck.1 \
939         man/hinfo.1 \
940         man/hscan.1 \
941         man/hspace.1 \
942         man/hroller.1 \
943         man/htools.1 \
944         man/mon-collector.7
945
946 # Remove extensions from all filenames in man_MANS
947 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
948
949 manrst = $(patsubst %,%.rst,$(mannoext))
950 manhtml = $(patsubst %.rst,%.html,$(manrst))
951 mangen = $(patsubst %.rst,%.gen,$(manrst))
952 maninput = \
953         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
954         $(patsubst %.html,%.html.in,$(manhtml)) \
955         $(mangen)
956
957 TEST_FILES = \
958         test/data/htools/clean-nonzero-score.data \
959         test/data/htools/common-suffix.data \
960         test/data/htools/empty-cluster.data \
961         test/data/htools/hail-alloc-drbd.json \
962         test/data/htools/hail-alloc-invalid-twodisks.json \
963         test/data/htools/hail-alloc-twodisks.json \
964         test/data/htools/hail-change-group.json \
965         test/data/htools/hail-invalid-reloc.json \
966         test/data/htools/hail-node-evac.json \
967         test/data/htools/hail-reloc-drbd.json \
968         test/data/htools/hbal-excl-tags.data \
969         test/data/htools/hbal-split-insts.data \
970         test/data/htools/invalid-node.data \
971         test/data/htools/missing-resources.data \
972         test/data/htools/n1-failure.data \
973         test/data/htools/rapi/groups.json \
974         test/data/htools/rapi/info.json \
975         test/data/htools/rapi/instances.json \
976         test/data/htools/rapi/nodes.json \
977         test/hs/shelltests/htools-balancing.test \
978         test/hs/shelltests/htools-basic.test \
979         test/hs/shelltests/htools-dynutil.test \
980         test/hs/shelltests/htools-excl.test \
981         test/hs/shelltests/htools-hail.test \
982         test/hs/shelltests/htools-hspace.test \
983         test/hs/shelltests/htools-invalid.test \
984         test/hs/shelltests/htools-multi-group.test \
985         test/hs/shelltests/htools-no-backend.test \
986         test/hs/shelltests/htools-rapi.test \
987         test/hs/shelltests/htools-single-group.test \
988         test/hs/shelltests/htools-text-backend.test \
989         test/hs/shelltests/htools-mon-collector.test \
990         test/data/bdev-drbd-8.0.txt \
991         test/data/bdev-drbd-8.3.txt \
992         test/data/bdev-drbd-disk.txt \
993         test/data/bdev-drbd-net-ip4.txt \
994         test/data/bdev-drbd-net-ip6.txt \
995         test/data/bdev-rbd/json_output_empty.txt \
996         test/data/bdev-rbd/json_output_extra_matches.txt \
997         test/data/bdev-rbd/json_output_no_matches.txt \
998         test/data/bdev-rbd/json_output_ok.txt \
999         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1000         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1001         test/data/bdev-rbd/plain_output_new_ok.txt \
1002         test/data/bdev-rbd/plain_output_old_empty.txt \
1003         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1004         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1005         test/data/bdev-rbd/plain_output_old_ok.txt \
1006         test/data/bdev-rbd/output_invalid.txt \
1007         test/data/cert1.pem \
1008         test/data/cert2.pem \
1009         test/data/instance-minor-pairing.txt \
1010         test/data/ip-addr-show-dummy0.txt \
1011         test/data/ip-addr-show-lo-ipv4.txt \
1012         test/data/ip-addr-show-lo-ipv6.txt \
1013         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1014         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1015         test/data/ip-addr-show-lo-oneline.txt \
1016         test/data/ip-addr-show-lo.txt \
1017         test/data/kvm_0.12.5_help.txt \
1018         test/data/kvm_0.15.90_help.txt \
1019         test/data/kvm_0.9.1_help.txt \
1020         test/data/kvm_0.9.1_help_boot_test.txt \
1021         test/data/kvm_1.0_help.txt \
1022         test/data/kvm_1.1.2_help.txt \
1023         test/data/ovfdata/compr_disk.vmdk.gz \
1024         test/data/ovfdata/config.ini \
1025         test/data/ovfdata/corrupted_resources.ovf \
1026         test/data/ovfdata/empty.ini \
1027         test/data/ovfdata/empty.ovf \
1028         test/data/ovfdata/ganeti.mf \
1029         test/data/ovfdata/ganeti.ovf \
1030         test/data/ovfdata/gzip_disk.ovf \
1031         test/data/ovfdata/new_disk.vmdk \
1032         test/data/ovfdata/no_disk.ini \
1033         test/data/ovfdata/no_disk_in_ref.ovf \
1034         test/data/ovfdata/no_os.ini \
1035         test/data/ovfdata/no_ovf.ova \
1036         test/data/ovfdata/other/rawdisk.raw \
1037         test/data/ovfdata/ova.ova \
1038         test/data/ovfdata/rawdisk.raw \
1039         test/data/ovfdata/second_disk.vmdk \
1040         test/data/ovfdata/unsafe_path.ini \
1041         test/data/ovfdata/virtualbox.ovf \
1042         test/data/ovfdata/wrong_config.ini \
1043         test/data/ovfdata/wrong_extension.ovd \
1044         test/data/ovfdata/wrong_manifest.mf \
1045         test/data/ovfdata/wrong_manifest.ovf \
1046         test/data/ovfdata/wrong_ova.ova \
1047         test/data/ovfdata/wrong_xml.ovf \
1048         test/data/proc_drbd8.txt \
1049         test/data/proc_drbd80-emptyline.txt \
1050         test/data/proc_drbd83.txt \
1051         test/data/proc_drbd83_sync.txt \
1052         test/data/proc_drbd83_sync_want.txt \
1053         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1054         test/data/sys_drbd_usermode_helper.txt \
1055         test/data/vgreduce-removemissing-2.02.02.txt \
1056         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1057         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1058         test/data/vgs-missing-pvs-2.02.02.txt \
1059         test/data/vgs-missing-pvs-2.02.66.txt \
1060         test/py/ganeti-cli.test \
1061         test/py/gnt-cli.test \
1062         test/py/import-export_unittest-helper
1063
1064 python_tests = \
1065         doc/examples/rapi_testutils.py \
1066         test/py/cfgupgrade_unittest.py \
1067         test/py/docs_unittest.py \
1068         test/py/ganeti.asyncnotifier_unittest.py \
1069         test/py/ganeti.backend_unittest-runasroot.py \
1070         test/py/ganeti.backend_unittest.py \
1071         test/py/ganeti.bdev_unittest.py \
1072         test/py/ganeti.cli_unittest.py \
1073         test/py/ganeti.client.gnt_cluster_unittest.py \
1074         test/py/ganeti.client.gnt_instance_unittest.py \
1075         test/py/ganeti.client.gnt_job_unittest.py \
1076         test/py/ganeti.cmdlib_unittest.py \
1077         test/py/ganeti.compat_unittest.py \
1078         test/py/ganeti.confd.client_unittest.py \
1079         test/py/ganeti.config_unittest.py \
1080         test/py/ganeti.constants_unittest.py \
1081         test/py/ganeti.daemon_unittest.py \
1082         test/py/ganeti.errors_unittest.py \
1083         test/py/ganeti.hooks_unittest.py \
1084         test/py/ganeti.ht_unittest.py \
1085         test/py/ganeti.http_unittest.py \
1086         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1087         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1088         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1089         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1090         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1091         test/py/ganeti.hypervisor_unittest.py \
1092         test/py/ganeti.impexpd_unittest.py \
1093         test/py/ganeti.jqueue_unittest.py \
1094         test/py/ganeti.jstore_unittest.py \
1095         test/py/ganeti.locking_unittest.py \
1096         test/py/ganeti.luxi_unittest.py \
1097         test/py/ganeti.masterd.iallocator_unittest.py \
1098         test/py/ganeti.masterd.instance_unittest.py \
1099         test/py/ganeti.mcpu_unittest.py \
1100         test/py/ganeti.netutils_unittest.py \
1101         test/py/ganeti.objects_unittest.py \
1102         test/py/ganeti.opcodes_unittest.py \
1103         test/py/ganeti.outils_unittest.py \
1104         test/py/ganeti.ovf_unittest.py \
1105         test/py/ganeti.qlang_unittest.py \
1106         test/py/ganeti.query_unittest.py \
1107         test/py/ganeti.rapi.baserlib_unittest.py \
1108         test/py/ganeti.rapi.client_unittest.py \
1109         test/py/ganeti.rapi.resources_unittest.py \
1110         test/py/ganeti.rapi.rlib2_unittest.py \
1111         test/py/ganeti.rapi.testutils_unittest.py \
1112         test/py/ganeti.rpc_unittest.py \
1113         test/py/ganeti.runtime_unittest.py \
1114         test/py/ganeti.serializer_unittest.py \
1115         test/py/ganeti.server.rapi_unittest.py \
1116         test/py/ganeti.ssconf_unittest.py \
1117         test/py/ganeti.ssh_unittest.py \
1118         test/py/ganeti.storage_unittest.py \
1119         test/py/ganeti.tools.burnin_unittest.py \
1120         test/py/ganeti.tools.ensure_dirs_unittest.py \
1121         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1122         test/py/ganeti.tools.prepare_node_join_unittest.py \
1123         test/py/ganeti.uidpool_unittest.py \
1124         test/py/ganeti.utils.algo_unittest.py \
1125         test/py/ganeti.utils.filelock_unittest.py \
1126         test/py/ganeti.utils.hash_unittest.py \
1127         test/py/ganeti.utils.io_unittest-runasroot.py \
1128         test/py/ganeti.utils.io_unittest.py \
1129         test/py/ganeti.utils.log_unittest.py \
1130         test/py/ganeti.utils.lvm_unittest.py \
1131         test/py/ganeti.utils.mlock_unittest.py \
1132         test/py/ganeti.utils.nodesetup_unittest.py \
1133         test/py/ganeti.utils.process_unittest.py \
1134         test/py/ganeti.utils.retry_unittest.py \
1135         test/py/ganeti.utils.text_unittest.py \
1136         test/py/ganeti.utils.wrapper_unittest.py \
1137         test/py/ganeti.utils.x509_unittest.py \
1138         test/py/ganeti.utils_unittest.py \
1139         test/py/ganeti.vcluster_unittest.py \
1140         test/py/ganeti.workerpool_unittest.py \
1141         test/py/pycurl_reset_unittest.py \
1142         test/py/qa.qa_config_unittest.py \
1143         test/py/tempfile_fork_unittest.py
1144
1145 haskell_tests = test/hs/htest
1146
1147 dist_TESTS = \
1148         test/py/check-cert-expired_unittest.bash \
1149         test/py/daemon-util_unittest.bash \
1150         test/py/ganeti-cleaner_unittest.bash \
1151         test/py/import-export_unittest.bash \
1152         test/py/cli-test.bash \
1153         test/py/bash_completion.bash \
1154         $(python_tests)
1155
1156 nodist_TESTS =
1157 check_SCRIPTS =
1158
1159 if WANT_HSTESTS
1160 nodist_TESTS += $(haskell_tests)
1161 dist_TESTS += test/hs/offline-test.sh
1162 check_SCRIPTS += \
1163         test/hs/hpc-htools \
1164         test/hs/hpc-mon-collector \
1165         $(HS_BUILT_TEST_HELPERS)
1166 endif
1167
1168 TESTS = $(dist_TESTS) $(nodist_TESTS)
1169
1170 # Environment for all tests
1171 PLAIN_TESTS_ENVIRONMENT = \
1172         PYTHONPATH=. \
1173         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1174         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1175         $(RUN_IN_TEMPDIR)
1176
1177 # Environment for tests run by automake
1178 TESTS_ENVIRONMENT = \
1179         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1180
1181 all_python_code = \
1182         $(dist_sbin_SCRIPTS) \
1183         $(python_scripts) \
1184         $(pkglib_python_scripts) \
1185         $(nodist_pkglib_python_scripts) \
1186         $(nodist_tools_python_scripts) \
1187         $(python_tests) \
1188         $(pkgpython_PYTHON) \
1189         $(client_PYTHON) \
1190         $(hypervisor_PYTHON) \
1191         $(rapi_PYTHON) \
1192         $(server_PYTHON) \
1193         $(pytools_PYTHON) \
1194         $(http_PYTHON) \
1195         $(confd_PYTHON) \
1196         $(masterd_PYTHON) \
1197         $(impexpd_PYTHON) \
1198         $(utils_PYTHON) \
1199         $(watcher_PYTHON) \
1200         $(noinst_PYTHON) \
1201         $(qa_scripts)
1202
1203 srclink_files = \
1204         man/footer.rst \
1205         test/py/check-cert-expired_unittest.bash \
1206         test/py/daemon-util_unittest.bash \
1207         test/py/ganeti-cleaner_unittest.bash \
1208         test/py/import-export_unittest.bash \
1209         test/py/cli-test.bash \
1210         test/py/bash_completion.bash \
1211         test/hs/offline-test.sh \
1212         test/hs/cli-tests-defs.sh \
1213         $(all_python_code) \
1214         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1215         $(docinput)
1216
1217 check_python_code = \
1218         $(BUILD_BASH_COMPLETION) \
1219         $(CHECK_IMPORTS) \
1220         $(CHECK_HEADER) \
1221         $(DOCPP) \
1222         $(all_python_code)
1223
1224 lint_python_code = \
1225         ganeti \
1226         ganeti/http/server.py \
1227         $(dist_sbin_SCRIPTS) \
1228         $(python_scripts) \
1229         $(pkglib_python_scripts) \
1230         $(BUILD_BASH_COMPLETION) \
1231         $(CHECK_IMPORTS) \
1232         $(CHECK_HEADER) \
1233         $(DOCPP) \
1234         $(PYTHON_BOOTSTRAP)
1235
1236 standalone_python_modules = \
1237         lib/rapi/client.py \
1238         tools/ganeti-listrunner
1239
1240 pep8_python_code = \
1241         ganeti \
1242         ganeti/http/server.py \
1243         $(dist_sbin_SCRIPTS) \
1244         $(python_scripts) \
1245         $(pkglib_python_scripts) \
1246         $(BUILD_BASH_COMPLETION) \
1247         $(CHECK_HEADER) \
1248         $(DOCPP) \
1249         $(PYTHON_BOOTSTRAP) \
1250         qa
1251
1252 test/py/daemon-util_unittest.bash: daemons/daemon-util
1253
1254 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1255
1256 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1257
1258 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1259         sed -f $(REPLACE_VARS_SED) < $< > $@
1260         chmod +x $@
1261
1262 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1263         sed -f $(REPLACE_VARS_SED) < $< > $@
1264         chmod +x $@
1265
1266 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1267         sed -f $(REPLACE_VARS_SED) < $< > $@
1268         chmod +x $@
1269
1270 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1271         sed -f $(REPLACE_VARS_SED) < $< > $@
1272         chmod +x $@
1273
1274 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1275         sed -f $(REPLACE_VARS_SED) < $< > $@
1276
1277 doc/examples/bash_completion: BC_ARGS = --compact
1278 doc/examples/bash_completion-debug: BC_ARGS =
1279
1280 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1281         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1282         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1283         daemons/ganeti-cleaner \
1284         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1285         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1286           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1287
1288 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1289         lib/build/shell_example_lexer.py \
1290         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1291         @echo "Checking $< for hardcoded paths..."
1292         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1293           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1294           exit 1; \
1295         fi
1296         set -e ; \
1297         trap 'echo auto-removing $@; rm $@' EXIT; \
1298         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1299         $(CHECK_MAN_REFERENCES) $@; \
1300         trap - EXIT
1301
1302 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1303         @test -n "$(PANDOC)" || \
1304           { echo 'pandoc' not found during configure; exit 1; }
1305         set -o pipefail -e; \
1306         trap 'echo auto-removing $@; rm $@' EXIT; \
1307         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1308           sed -e 's/\\@/@/g' > $@; \
1309         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1310         $(CHECK_MAN_DASHES) $@; \
1311         trap - EXIT
1312
1313 man/%.html.in: man/%.gen man/footer.rst
1314         @test -n "$(PANDOC)" || \
1315           { echo 'pandoc' not found during configure; exit 1; }
1316         set -o pipefail ; \
1317         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1318           sed -e 's/\\@/@/g' > $@
1319
1320 man/%: man/%.in  $(REPLACE_VARS_SED)
1321         sed -f $(REPLACE_VARS_SED) < $< > $@
1322
1323 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1324         sed -f $(REPLACE_VARS_SED) < $< > $@
1325
1326 vcs-version:
1327         if test -d .git; then \
1328           git describe > $@; \
1329         elif test ! -f $@ ; then \
1330           echo "Cannot auto-generate $@ file"; exit 1; \
1331         fi
1332
1333 .PHONY: clean-vcs-version
1334 clean-vcs-version:
1335         rm -f vcs-version
1336
1337 .PHONY: regen-vcs-version
1338 regen-vcs-version:
1339         @set -e; \
1340         cd $(srcdir); \
1341         if test -d .git; then \
1342           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1343           git describe > $$T; \
1344           if ! cmp --quiet $$T vcs-version; then \
1345             mv $$T vcs-version; \
1346           fi; \
1347         fi
1348
1349 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1350         vcs-version $(built_base_sources)
1351         set -e; \
1352         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1353         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1354
1355 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1356         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1357         lib/jstore.py $(RUN_IN_TEMPDIR) \
1358         $(CONVERT_CONSTANTS) $(built_base_sources) \
1359         | lib/_vcsversion.py
1360         set -e; \
1361         { cat $< ; \
1362           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1363         } > $@
1364
1365 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1366         $(built_base_sources)
1367         set -e; \
1368         { cat $< ; \
1369           echo ; \
1370           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1371             echo "import $$name ()" ; \
1372           done ; \
1373         } > $@
1374
1375 lib/_autoconf.py: Makefile | stamp-directories
1376         set -e; \
1377         { echo '# This file is automatically generated, do not edit!'; \
1378           echo '#'; \
1379           echo ''; \
1380           echo '"""Build-time configuration for Ganeti.'; \
1381           echo '';\
1382           echo 'This file is autogenerated by the build process.'; \
1383           echo 'For any changes you need to re-run ./configure (and'; \
1384           echo 'not edit by hand).'; \
1385           echo ''; \
1386           echo '"""'; \
1387           echo ''; \
1388           echo '# pylint: disable=C0301,C0324'; \
1389           echo '# because this is autogenerated, we do not want'; \
1390           echo '# style warnings' ; \
1391           echo ''; \
1392           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1393           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1394           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1395           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1396           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1397           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1398           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1399           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1400           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1401           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1402           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1403           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1404           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1405           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1406           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1407           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1408           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1409           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1410           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1411           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1412           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1413           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1414           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1415           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1416           echo "KVM_PATH = '$(KVM_PATH)'"; \
1417           echo "IP_PATH = '$(IP_PATH)'"; \
1418           echo "SOCAT_PATH = '$(SOCAT)'"; \
1419           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1420           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1421           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1422           echo "TOOLSDIR = '$(toolsdir)'"; \
1423           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1424           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1425           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1426           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1427           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1428           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1429           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1430           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1431           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1432           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1433           echo "RAPI_USER = '$(RAPI_USER)'"; \
1434           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1435           echo "CONFD_USER = '$(CONFD_USER)'"; \
1436           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1437           echo "NODED_USER = '$(NODED_USER)'"; \
1438           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1439           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1440           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1441           echo "HTOOLS = True"; \
1442           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1443           echo "XEN_CMD = '$(XEN_CMD)'"; \
1444           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1445           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1446           echo "ENABLE_MONITORING = $(ENABLE_MONITORING)"; \
1447 ## Write dictionary with man page name as the key and the section number as the
1448 ## value
1449           echo "MAN_PAGES = {"; \
1450           for i in $(notdir $(man_MANS)); do \
1451             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1452           done; \
1453           echo "}"; \
1454         } > $@
1455
1456 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1457         set -e; \
1458         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1459         { echo '# This file is automatically generated, do not edit!'; \
1460           echo '#'; \
1461           echo ''; \
1462           echo '"""Build-time VCS version number for Ganeti.'; \
1463           echo '';\
1464           echo 'This file is autogenerated by the build process.'; \
1465           echo 'For any changes you need to re-run ./configure (and'; \
1466           echo 'not edit by hand).'; \
1467           echo ''; \
1468           echo '"""'; \
1469           echo ''; \
1470           echo '# pylint: disable=C0301,C0324'; \
1471           echo '# because this is autogenerated, we do not want'; \
1472           echo '# style warnings' ; \
1473           echo ''; \
1474           echo "VCS_VERSION = '$$VCSVER'"; \
1475         } > $@
1476
1477 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1478         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1479
1480 $(SHELL_ENV_INIT): Makefile stamp-directories
1481         set -e; \
1482         { echo '# Allow overriding for tests'; \
1483           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1484           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1485           echo; \
1486           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1487           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1488           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1489           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1490           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1491         } > $@
1492
1493 ## Writes sed script to replace placeholders with build-time values. The
1494 ## additional quotes after the first @ sign are necessary to stop configure
1495 ## from replacing those values as well.
1496 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1497         set -e; \
1498         { echo 's#@''PREFIX@#$(prefix)#g'; \
1499           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1500           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1501           echo 's#@''BINDIR@#$(bindir)#g'; \
1502           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1503           echo 's#@''LIBDIR@#$(libdir)#g'; \
1504           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1505           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1506           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1507           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1508           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1509           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1510           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1511           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1512           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1513           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1514           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1515           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1516           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1517           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1518           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1519           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1520           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1521           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1522           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1523           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1524           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1525           echo; \
1526           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1527           echo '  r $(SHELL_ENV_INIT)'; \
1528           echo '  d'; \
1529           echo '}'; \
1530         } > $@
1531
1532 # Using deferred evaluation
1533 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1534 daemons/ganeti-watcher: MODULE = ganeti.watcher
1535 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1536 tools/burnin: MODULE = ganeti.tools.burnin
1537 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1538 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1539 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1540 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1541 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1542
1543 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1544         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1545         set -e; \
1546         { echo '#!/usr/bin/python'; \
1547           echo '# This file is automatically generated, do not edit!'; \
1548           echo "# Edit $(MODULE) instead."; \
1549           echo; \
1550           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1551           echo; \
1552           echo '# pylint: disable=C0103'; \
1553           echo '# C0103: Invalid name'; \
1554           echo; \
1555           echo 'import sys'; \
1556           echo 'import $(MODULE) as main'; \
1557           echo; \
1558           echo '# Temporarily alias commands until bash completion'; \
1559           echo '# generator is changed'; \
1560           echo 'if hasattr(main, "commands"):'; \
1561           echo '  commands = main.commands # pylint: disable=E1101'; \
1562           echo 'if hasattr(main, "aliases"):'; \
1563           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1564           echo; \
1565           echo 'if __name__ == "__main__":'; \
1566           echo '  sys.exit(main.Main())'; \
1567         } > $@
1568         chmod u+x $@
1569
1570 $(HS_BUILT_TEST_HELPERS): Makefile
1571         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1572         set -e; \
1573         { echo '#!/bin/sh'; \
1574           echo '# This file is automatically generated, do not edit!'; \
1575           echo "# Edit Makefile.am instead."; \
1576           echo; \
1577           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1578         } > $@
1579         chmod u+x $@
1580
1581 stamp-directories: Makefile
1582         $(MAKE) $(AM_MAKEFLAGS) ganeti
1583         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1584         touch $@
1585
1586 # We need to create symlinks because "make distcheck" will not install Python
1587 # files when building.
1588 stamp-srclinks: Makefile | stamp-directories
1589         set -e; \
1590         for i in $(srclink_files); do \
1591           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1592             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1593           fi; \
1594         done
1595         touch $@
1596
1597 .PHONY: ganeti
1598 ganeti:
1599         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1600
1601 .PHONY: check-dirs
1602 check-dirs: $(GENERATED_FILES)
1603         @set -e; \
1604         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1605           error=; \
1606           while read dir; do \
1607             case "$$dir" in \
1608               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1609               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1610             esac; \
1611           done; \
1612           for dir in $(DIRS); do \
1613             if ! test -d "$$dir"; then \
1614               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1615               error=1; \
1616             fi \
1617           done; \
1618           test -z "$$error"; \
1619         }
1620
1621 .PHONY: check-local
1622 check-local: check-dirs $(GENERATED_FILES)
1623         $(CHECK_PYTHON_CODE) $(check_python_code)
1624         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1625         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1626         $(CHECK_NEWS) < $(top_srcdir)/NEWS
1627         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1628         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1629         error= ; \
1630         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1631           echo "Incorrect version in README, expected $$expver" >&2; \
1632           error=1; \
1633         fi; \
1634         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1635             doc/security.rst; do \
1636           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1637             "Documents Ganeti version $$expver"; then \
1638             echo "Incorrect version in $$file, expected $$expver" >&2; \
1639             error=1; \
1640           fi; \
1641         done; \
1642         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1643           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1644           error=1; \
1645         fi; \
1646         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1647           ".. Last updated for Ganeti $$expver"; then \
1648           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1649           error=1; \
1650         fi; \
1651         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1652           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1653             echo "Longest line in $$file is longer than 80 characters" >&2; \
1654             error=1; \
1655           fi; \
1656         done; \
1657         test -z "$$error"
1658
1659 .PHONY: hs-tests
1660 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1661         @rm -f htest.tix
1662         ./test/hs/htest
1663
1664 .PHONY: hs-shell
1665 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1666         @rm -f hpc-htools.tix hpc-mon-collector.tix
1667         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1668
1669 .PHONY: hs-check
1670 hs-check: hs-tests hs-shell
1671
1672 # E111: indentation is not a multiple of four
1673 # E121: continuation line indentation is not a multiple of four
1674 #       (since our indent level is not 4)
1675 # E125: continuation line does not distinguish itself from next logical line
1676 #       (since our indent level is not 4)
1677 # E127: continuation line over-indented for visual indent
1678 #       (since our indent level is not 4)
1679 # note: do NOT add E128 here; it's a valid style error in most cases!
1680 # I've seen real errors, but also some cases were we indent wrongly
1681 # due to line length; try to rework the cases where it is triggered,
1682 # instead of silencing it
1683 # E261: at least two spaces before inline comment
1684 # E501: line too long (80 characters)
1685 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1686
1687 # For excluding pep8 expects filenames only, not whole paths
1688 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1689
1690 LINT_TARGETS = pylint pylint-qa
1691 if HAS_PEP8
1692 LINT_TARGETS += pep8
1693 endif
1694 if HAS_HLINT
1695 LINT_TARGETS += hlint
1696 endif
1697
1698 .PHONY: lint
1699 lint: $(LINT_TARGETS)
1700
1701 .PHONY: pylint
1702 pylint: $(GENERATED_FILES)
1703         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1704         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1705
1706 .PHONY: pylint-qa
1707 pylint-qa: $(GENERATED_FILES)
1708         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1709         cd $(top_srcdir)/qa && \
1710           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1711           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1712
1713 .PHONY: pep8
1714 pep8: $(GENERATED_FILES)
1715         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1716         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1717           --repeat $(pep8_python_code)
1718
1719 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1720 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1721 .PHONY: hlint
1722 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1723         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1724         @rm -f doc/hs-lint.html
1725         if tty -s; then C="-c"; else C=""; fi; \
1726         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1727           --ignore "Use first" \
1728           --ignore "Use &&&" \
1729           --ignore "Use void" \
1730           --ignore "Reduce duplication" \
1731           --hint src/lint-hints \
1732           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1733         @if [ ! -f doc/hs-lint.html ]; then \
1734           echo "All good" > doc/hs-lint.html; \
1735         fi
1736
1737 # a dist hook rule for updating the vcs-version file; this is
1738 # hardcoded due to where it needs to build the file...
1739 dist-hook:
1740         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1741         rm -f $(top_distdir)/vcs-version
1742         cp -p $(srcdir)/vcs-version $(top_distdir)
1743
1744 # a distcheck hook rule for catching revision control directories
1745 distcheck-hook:
1746         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1747           echo "Found revision control files in final archive." 1>&2; \
1748           exit 1; \
1749         fi
1750         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1751           echo "Found Python byte code in final archive." 1>&2; \
1752           exit 1; \
1753         fi
1754         if find $(top_distdir) -name '*~' | grep .; then \
1755           echo "Found backup files in final archive." 1>&2; \
1756           exit 1; \
1757         fi
1758 # Empty files or directories should not be distributed. They can cause
1759 # unnecessary warnings for packagers. Directories used by automake during
1760 # distcheck must be excluded.
1761         if find $(top_distdir) -empty -and -not \( \
1762             -path $(top_distdir)/_build -or \
1763             -path $(top_distdir)/_inst \) | grep .; then \
1764           echo "Found empty files or directories in final archive." 1>&2; \
1765           exit 1; \
1766         fi
1767         if test -n "$(BUILD_RELEASE)" && \
1768            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1769            echo "Found unreleased version in NEWS." >&2; \
1770            exit 1; \
1771         fi
1772         if test -e $(top_distdir)/doc/man-html; then \
1773           echo "Found documentation including man pages in final archive" >&2; \
1774           exit 1; \
1775         fi
1776
1777 # When building a release, stricter checks should be used
1778 distcheck-release dist-release: export BUILD_RELEASE = 1
1779 distcheck-release: distcheck
1780
1781 distrebuildcheck: dist
1782         set -e; \
1783         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1784         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1785         cd $$builddir; \
1786         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1787         cd $(distdir); \
1788         ./configure; \
1789         $(MAKE) maintainer-clean; \
1790         cp $(abs_srcdir)/vcs-version .; \
1791         ./configure; \
1792         $(MAKE) $(AM_MAKEFLAGS)
1793
1794 dist-release: dist
1795         set -e; \
1796         for i in $(DIST_ARCHIVES); do \
1797           echo -n "Checking $$i ... "; \
1798           autotools/check-tar < $$i; \
1799           echo OK; \
1800         done
1801
1802 install-exec-local:
1803         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1804           "$(DESTDIR)${localstatedir}/log/ganeti" \
1805           "$(DESTDIR)${localstatedir}/run/ganeti"
1806
1807 .PHONY: apidoc
1808 if WANT_HSAPIDOC
1809 apidoc: py-apidoc hs-apidoc
1810 else
1811 apidoc: py-apidoc
1812 endif
1813
1814 .PHONY: py-apidoc
1815 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1816         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1817         $(RUN_IN_TEMPDIR) epydoc -v \
1818           --conf $(CURDIR)/epydoc.conf \
1819           --output $(CURDIR)/$(APIDOC_PY_DIR)
1820
1821 .PHONY: hs-apidoc
1822 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1823
1824 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1825         @test -n "$(HSCOLOUR)" || \
1826             { echo 'HsColour' not found during configure; exit 1; }
1827         @test -n "$(HADDOCK)" || \
1828             { echo 'haddock' not found during configure; exit 1; }
1829         rm -rf $(APIDOC_HS_DIR)/*
1830         for i in $(ALL_APIDOC_HS_DIRS); do \
1831           @mkdir_p@ $$i; \
1832           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1833         done
1834         set -e ; \
1835         export LC_ALL=en_US.UTF-8; \
1836         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1837         if [ "$(HS_NOCURL)" ]; \
1838         then OPTGHC="$$OPTGHC --optghc=$(HS_NOCURL)"; \
1839         fi; \
1840         if [ "$(HS_PARALLEL3)" ]; \
1841         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1842         fi; \
1843         if [ "$(HS_REGEX_PCRE)" ]; \
1844         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1845         fi; \
1846         for file in $(HS_LIBTESTBUILT_SRCS); do \
1847           f_nosrc=$${file##src/}; \
1848           f_notst=$${f_nosrc##test/hs/}; \
1849           f_html=$${f_notst%%.hs}.html; \
1850           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1851         done ; \
1852         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1853           -t ganeti -p src/haddock-prologue \
1854           --source-module="%{MODULE/.//}.html" \
1855           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1856           $$OPTGHC \
1857           $(HS_LIBTESTBUILT_SRCS)
1858
1859 .PHONY: TAGS
1860 TAGS: $(GENERATED_FILES)
1861         rm -f TAGS
1862         $(GHC) -e ":etags" -v0 \
1863           $(filter-out -O -Werror,$(HFLAGS)) \
1864           $(HS_NOCURL) $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1865           $(HS_LIBTEST_SRCS)
1866         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1867           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1868           -path './qa/*.py' | \
1869           etags -l python -a -
1870
1871 .PHONY: coverage
1872 if WANT_HTOOLS
1873 coverage: py-coverage hs-coverage
1874 else
1875 coverage: py-coverage
1876 endif
1877
1878 .PHONY: py-coverage
1879 py-coverage: $(GENERATED_FILES) $(python_tests)
1880         @test -n "$(PYCOVERAGE)" || \
1881             { echo 'python-coverage' not found during configure; exit 1; }
1882         set -e; \
1883         COVERAGE=$(PYCOVERAGE) \
1884         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1885         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1886         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1887         $(PLAIN_TESTS_ENVIRONMENT) \
1888         $(abs_top_srcdir)/autotools/gen-py-coverage \
1889         $(python_tests)
1890
1891 .PHONY: hs-coverage
1892 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1893         rm -f *.tix
1894         $(MAKE) $(AM_MAKEFLAGS) hs-check
1895         @mkdir_p@ $(COVERAGE_HS_DIR)
1896         hpc sum --union $(HPCEXCL) \
1897           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1898         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1899         hpc report coverage-hs.tix
1900         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1901
1902 # Special "kind-of-QA" target for htools, needs special setup (all
1903 # tools compiled with -fhpc)
1904 .PHONY: live-test
1905 live-test: all
1906         set -e ; \
1907         cd src; \
1908         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1909         rm -f *.tix *.mix; \
1910         ./live-test.sh; \
1911         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1912           --output=live-test.tix ; \
1913         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1914         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1915           --srcdir=.. $(HPCEXCL) ; \
1916         hpc report --srcdir=.. live-test $(HPCEXCL)
1917
1918 commit-check: distcheck lint apidoc
1919
1920 .PHONY: gitignore-check
1921 gitignore-check:
1922         @if [ -n "`git status --short`" ]; then \
1923           echo "Git status is not clean!" 1>&2 ; \
1924           git status --short; \
1925           exit 1; \
1926         fi
1927
1928 # target to rebuild all man pages (both groff and html output)
1929 .PHONY: man
1930 man: $(man_MANS) $(manhtml)
1931
1932 # Target that builds all binaries (including those that are not
1933 # rebuilt except when running the tests)
1934 .PHONY: really-all
1935 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
1936
1937 # we don't need the ancient implicit rules:
1938 %: %,v
1939 %: RCS/%,v
1940 %: RCS/%
1941 %: s.%
1942 %: SCCS/s.%
1943
1944 -include ./Makefile.local
1945
1946 # vim: set noet :